'use strict';  
/* Common code for front end in both EntryWizard and  EWZ-Rating */
    
/* To stop IE from generating errors if a console.log call was left in */
function fixConsole()
{
    if (console === undefined)
    {
        console = {}; // define it if it doesn't exist already
    }
    if (console.log === undefined)
    {
        console.log = function() {
        };
    }
    if (console.dir === undefined)
    {
        console.dir = function() {
        };
    }
}

function ewz_alert( alert_id, msg, pnum ){
    var title = '** Notice **';
        jQuery('<div class="alertDiv' + alert_id + '"></div>').html('[' + alert_id + '] &nbsp; ' +  msg ).dialog({
            dialogClass: "ewz-no-close alert ewz_alert" + pnum.toString(),
            title: title,
            resizable: false,
            modal: true,
            buttons:[ {
                        text:"Ok",
                        id: "ewz_alert" + pnum.toString(),
                        click: function(){
                                  jQuery( this ).dialog( "close" );
                               }
                      }
                    ]
        });
}

function ewz_alert_and_reload( alert_id, msg, pnum){
    var title = '** Notice **';
    jQuery('<div></div>').html('[' + alert_id + '] &nbsp; ' + msg).dialog({
        dialogClass: "ewz-no-close alert ewz_alert" + pnum.toString(),
        title: title,
        resizable: false,
        modal: true,
        buttons:[ {
                    text:"Ok",
                    id: "ewz_alert" + pnum.toString(),
                    click: function(){
                              document.location.reload(true);                              
                           }
                  }
                ]
    });
}

function ewz_confirm(  msg, truefunc, falsefunc, pnum ){
    var title = 'Please Confirm';

    jQuery('<div></div>').html(msg).dialog({
        dialogClass: "ewz-no-close alert ewz_alert" + pnum.toString(),
        title: title,
        resizable: false,
        modal: true,
        buttons:[ {
                      text: "Yes, Go Ahead",
                      id: "ewz_confirm" + pnum.toString(),
                      click: function(){ 
                                          if (typeof truefunc == 'function') {
                                              setTimeout(truefunc, 50);
                                          }                 
                                          jQuery(this).dialog('close');
                                       }
                  },
                  {
                      text: "No, Cancel",
                        id: "ewz_cancel" + pnum.toString(),
                      click: function(){
                                          if (typeof falsefunc == 'function') {
                                              setTimeout(falsefunc, 50);
                                          }
                                          jQuery(this).dialog('close');
                                       }
                 }
               ]
    });
}

function isblank(string)
{
   if ( string === undefined) {
      return true;
   }
   if (null == string) {
      return true;
   }
   var blankre = /^\s*$/;
   return (blankre.test(string));
}
